// Rozwiązanie zadania Wioska logiki
// Zawody I stopnia XVII OIJ
// oij.edu.pl

// Bartosz Kostka
#include "bits/stdc++.h"

using namespace std;

enum Rasa {
  ORK,
  KRASNOLUD,
  ELF,
};

enum Pora {
  DZIEN, 
  NOC
};

// Każda wypowiedź składa się z trzech informacji:
//  - kto jest jej autorem
//  - o kim jest ta wypowiedź
//  - o jakiej rasie jest mowa.
struct Wypowiedz {
  int autor_wypowiedzi;
  int przedmiot_wypowiedzi;
  Rasa rasa;
};

map <string, int> mapa_imion;

Rasa RasaZNapisu(string napis_z_rasa) {
  if (napis_z_rasa == "orkiem") return ORK;
  if (napis_z_rasa == "krasnoludem") return KRASNOLUD;
  if (napis_z_rasa == "elfem") return ELF;
}

string NapisZMaski(int maska) {
  if (maska == 1<<ORK) return "orkiem";
  if (maska == 1<<KRASNOLUD) return "krasnoludem";
  if (maska == 1<<ELF) return "elfem";
}

// Zwraca maskę zawierającą wszystkie rasy poza tą w argumencie.
int InneRasy(Rasa rasa) {
  int wszystkie_rasy = (1<<3)-1;
  return wszystkie_rasy ^ (1<<rasa);
}

// Wyrażenia regularne zawierające dwa formaty wypowiedzi.
regex kWypowiedzOSamymSobie{"([A-Za-z]+): Jestem ([a-z]+)."};
regex kWypowiedzOKimsInnym("([A-Za-z]+): ([A-Za-z]+) jest ([a-z]+).");

// Parsuje wypowiedz w formacie tekstowym używając wyrażeń regularnych 
// i zwraca odpowiedni obiekt Wypowiedz.
Wypowiedz ParsujWypowiedz(string wypowiedz) {
  smatch match;
  if (regex_match(wypowiedz, match, kWypowiedzOSamymSobie)) {
    return Wypowiedz{mapa_imion[match[1]], mapa_imion[match[1]], 
                     RasaZNapisu(match[2])};
  }
  if (regex_match(wypowiedz, match, kWypowiedzOKimsInnym)) {
    return Wypowiedz{mapa_imion[match[1]], mapa_imion[match[2]], 
                     RasaZNapisu(match[3])};
  }
}

int main() {
  int N, K;
  cin >> N >> K;
  vector <string> imiona(N);
  for (int i=0; i<N; i++) {
    cin >> imiona[i];
    mapa_imion[imiona[i]] = i;
  }

  // Jako że dalej w kodzie chcemy użyć funkjcji `getline`, musimy
  // tutaj wczytać znak końca linii.
  string koniec_linii;
  getline(cin, koniec_linii);
  
  vector<Wypowiedz> wypowiedzi;
  for (int i=0; i<K; i++) {
    string wypowiedz;
    getline(cin, wypowiedz);
    wypowiedzi.push_back(ParsujWypowiedz(wypowiedz));
  }

  vector <vector <int>> mozliwe_scenariusze;
  // Rozważamy wszystkie możliwości, czy mamy dzień czy noc...
  for (Pora pora : {DZIEN, NOC}) {
    // ... oraz dla każdej postaci, czy mówi prawdę (zapalony bit),
    // lub czy kłamie (zgaszony bit).
    for (int maska = 0; maska < (1<<N); maska++) {
      // Wektor mozliwosci okresla wszystkie rasy, jakie moze miec dana 
      // postac.
      vector <int> mozliwosci(N);
      for (int i=0; i<N; i++) {
        // Poczatkowo ustawiamy możliwe rasy, w zależności od tego
        // czy mówi prawdę i jaka jest pora dnia.
        if ((1<<i) & maska) {
          mozliwosci[i] |= (1<<KRASNOLUD);
          if (pora == DZIEN) mozliwosci[i] |= (1<<ELF);
        } else {
          mozliwosci[i] |= (1<<ORK);
          if (pora == NOC) mozliwosci[i] |= (1<<ELF);
        }
      }
      // Teraz przetwarzamy wszystkie wypowiedzi.
      for (auto [autor_wypowiedzi, przedmiot_wypowiedzi, rasa] : wypowiedzi) {
        // Sprawdzamy czy autor wypowiedzi mówi prawdę.
        bool czy_mowi_prawde = ((1<<autor_wypowiedzi) & maska);
        // I w zależności od tego aktualizujemy mozliwe rasy 
        // postaci, o której jest ta wypowiedź.
        mozliwosci[przedmiot_wypowiedzi] &= \
          czy_mowi_prawde ? (1<<rasa) : InneRasy(rasa);
      }
      // Sprawdzamy teraz, czy sytuacja jest możliwa, tj. czy każda postać
      // ma co najmniej jedną możliwą rasę.
      bool mozliwe = true;
      for (int i=0; i<N; i++) {
        if (mozliwosci[i] == 0) mozliwe = false;
      }
      // Jeżeli tak, zapisujemy ten scenariusz.
      if (mozliwe) mozliwe_scenariusze.push_back(mozliwosci);
    }
  }

  bool cos_wiadomo = false;
  // Następnie należy sprawdzić czy wśród wszystkich scneariuszy mamy spójne
  // informacje, tj. czy dla danej postaci we wszystkich możliwych scenariuszach
  // mamy tą samą (unikatową) rasę.
  if (!mozliwe_scenariusze.empty()) {
    for (int i=0; i<N; i++) {
      bool spojne = true;
      for (int j=0; j<(int)mozliwe_scenariusze.size(); j++) {
        if (mozliwe_scenariusze[j][i] != mozliwe_scenariusze[0][i]) {
          spojne = false;
        }
      }
      if (spojne and __builtin_popcount(mozliwe_scenariusze[0][i]) == 1) {
        cout << imiona[i] << " jest " 
             << NapisZMaski(mozliwe_scenariusze[0][i]) << ".\n";
        cos_wiadomo = true;
      }
    }
  }
  if (!cos_wiadomo) cout << "Nic nie wiadomo!" << "\n";
  return 0;
}